#pragma bank=2
#include "SpriteVendedor.h"
UINT8 bank_SPRITE_PLAYER = 2;

#include <gb/gb.h>

#include "Scroll.h"
#include "SpriteManager.h"

#include <rand.h>
#include "Keys.h"
#include "ZGBMain.h"
#include "Sound.h"

#define VELOCIDAD_MONO 4

const UINT8 animacion_monito_izq[] = {2, 0, 1};
const UINT8 animacion_monito_der[] = {2, 3, 2};
const UINT8 animacion_monita_izq[] = {2, 5, 4};
const UINT8 animacion_monita_der[] = {2, 7, 6};

UINT8* anim_izq = NULL;
UINT8* anim_der = NULL;

UINT16 playerX = 0;
UINT16 playerY = 0;
UINT8 powerUp = 0;

void Start_SPRITE_PLAYER() {
	
	UINT8 genero;
	genero = rand();
	
	powerUp = 0;
	
	if (genero%2 == 0) {
		anim_izq = animacion_monito_izq;
		anim_der = animacion_monito_der;
	} else {
		anim_izq = animacion_monita_izq;
		anim_der = animacion_monita_der;
	}
	
	SetSpriteAnim(THIS, anim_izq, 15u);
	
	THIS->coll_x = 2;
    THIS->coll_y = 0;
    THIS->coll_w = 12;
    THIS->coll_h = 16;
	
}

void Update_SPRITE_PLAYER() {
	
	UINT8 i;
    struct Sprite* spr;
	
	SPRITEMANAGER_ITERATE(i, spr) {
		if(spr->type == SPRITE_KEYENDING) {
			if(CheckCollision(THIS, spr)) {
				if (current_state != STATE_MISION) {
					SetState(STATE_OVER);
				}
				
			}
		}
		else if (spr->type == SPRITE_POWERUP) {
			if(CheckCollision(THIS, spr)) {
				SpriteManagerRemove(spr);
				spr->x = 0;
				powerUp = 1;
			}
		}
		else if(spr->type == SPRITE_FLAITE || spr->type == SPRITE_WEAVERTICAL || spr->type == SPRITE_WEAHORIZONTAL) {
			if(CheckCollision(THIS, spr)) {
				PlayFx(CHANNEL_4, 4, 0x0c, 0x41, 0x30, 0xc0);
				SetState(STATE_LEVEL);
			}
		}
	}
	
	if(KEY_PRESSED(J_UP)) {
        TranslateSprite(THIS, 0, -VELOCIDAD_MONO);
    } 
    if(KEY_PRESSED(J_DOWN)) {
        TranslateSprite(THIS, 0, VELOCIDAD_MONO);
    }
    if(KEY_PRESSED(J_LEFT)) {
        TranslateSprite(THIS, -VELOCIDAD_MONO, 0);
		SetSpriteAnim(THIS, anim_izq, 15u);
    }
    if(KEY_PRESSED(J_RIGHT)) {
        TranslateSprite(THIS, VELOCIDAD_MONO, 0);
		SetSpriteAnim(THIS, anim_der, 15u);
    }
	
	playerX = THIS -> x;
	playerY = THIS -> y;
}

void Destroy_SPRITE_PLAYER() {
}