#include "ZGBMain.h"

#include "StateGame.h"
#include "StateMision.h"
#include "StateLevel.h"
#include "StateOver.h"

#include "SpriteVendedor.h"
#include "SpriteMonitos.h"
#include "SpritePlayer.h"
#include "SpriteKeyEnding.h"
#include "SpriteWeaHorizontal.h"
#include "SpriteWeaVertical.h"
#include "SpriteFlaite.h"
#include "SpritePowerup.h"

#include "../res/src/tex_vendedor.h"
#include "../res/src/tex_monitos.h"
#include "../res/src/tex_auto.h"
#include "../res/src/tex_loko.h"
#include "../res/src/tex_flaite.h"
#include "../res/src/tex_powerups.h"

UINT8 next_state = STATE_GAME;

SET_N_STATES(N_STATES);
SET_N_SPRITE_TYPES(N_SPRITE_TYPES);

void InitStates() {
	INIT_STATE(STATE_GAME);
	INIT_STATE(STATE_MISION);
	INIT_STATE(STATE_LEVEL);
	INIT_STATE(STATE_OVER);
}

void InitSprites() {
	//aqui declaro (cual logico), textura, banco, tamanio frame, cuantos frames cargo
	INIT_SPRITE(SPRITE_VENDEDOR, tex_vendedor, 3, FRAME_16x16, 2);
	INIT_SPRITE(SPRITE_WEAHORIZONTAL, tex_auto, 3, FRAME_16x16, 2);
	INIT_SPRITE(SPRITE_WEAVERTICAL, tex_loko, 3, FRAME_16x16, 2);
	INIT_SPRITE(SPRITE_MONITOS, tex_monitos, 3, FRAME_16x16, 8);
	INIT_SPRITE(SPRITE_PLAYER, tex_monitos, 3, FRAME_16x16, 8);
	INIT_SPRITE(SPRITE_FLAITE, tex_flaite, 3, FRAME_16x16, 3);
	INIT_SPRITE(SPRITE_POWERUP, tex_powerups, 3, FRAME_16x16, 3);
	INIT_SPRITE(SPRITE_KEYENDING, tex_powerups, 3, FRAME_16x16, 3);

}

#include "Math.h"
UINT8 GetTileReplacement(UINT8* tile_ptr, UINT8* tile) {
	
	if(current_state == STATE_LEVEL) {
		*tile = 0;
		switch(*tile_ptr) {
				case 93: return SPRITE_KEYENDING;
				case 13: return SPRITE_WEAHORIZONTAL;
				case 14: return SPRITE_WEAVERTICAL;
				case 16: return SPRITE_FLAITE;
				case 125: return SPRITE_POWERUP;
		}
		*tile = *tile_ptr;
	}
	
	if(current_state == STATE_MISION) {
		*tile = 0;
		switch(*tile_ptr) {
				case 93: return SPRITE_KEYENDING;
				case 125: return SPRITE_PLAYER;
		}
		*tile = *tile_ptr;
	}
	/*
		if(U_LESS_THAN(255 - (UINT16)*tile_ptr, N_SPRITE_TYPES)) {
			*tile = 0;
			return 255 - (UINT16)*tile_ptr;
		}

		*tile = *tile_ptr;
	}*/

	return 255u;
}